package protocolP2P;
import protocolP2P.Payload;
import protocolP2P.RequestResponseCode;
import exception.ProtocolError;
import exception.InternalError;

/** Representation of payload for load response.
 * @author	Louis Royer
 * @author	Flavien Haas
 * @author	JS Auge
 * @version	1.0
 */
public class FilePart extends Payload {
	private static final RequestResponseCode requestResponseCode = RequestResponseCode.LOAD_RESPONSE;
	private String filename;
	private int totalSize;
	private int offset;
	private byte[] partialContent;

	/** Constructor (typically used by server) with informations about file part to send as parameters.
	 * @param filename	name of the file to send
	 * @param totalSize	total size of the file to send
	 * @param offset	where in the file begins the part we are sending
	 * @param partialContent	content of the file we send
	 */
	public FilePart(String filename, int totalSize, int offset, byte[] partialContent) {
		this.filename = filename;
		this.totalSize = totalSize;
		this.offset = offset;
		this.partialContent = partialContent;
	}

	/** Constructor (typically used by client) with datagram received as parameter.
	 * @param datagram	the full datagram received
	 * @throws	ProtocolError
	 * @throws	InternalError
	 */
	public FilePart(byte[] datagram) throws ProtocolError, InternalError {
		//TODO
		/* assert to help debugging */
		assert RequestResponseCode.fromCode(datagram[RequestResponseCode.RRCODE_POSITION]) == RequestResponseCode.LOAD_RESPONSE : "FilePart subclass is incompatible with this datagram, request/response code must be checked before using this constructor";
		/* InternalErrorException */
		if (RequestResponseCode.fromCode(datagram[RequestResponseCode.RRCODE_POSITION]) != RequestResponseCode.LOAD_RESPONSE) {
			throw new InternalError();
		}
		int size = getPayloadSize(datagram);
	}

	/** Returns a byte[] containing datagram with padding.
	 * This datagram is still incomplete and should not be send directly.
	 * ProtocolP2PDatagram will use this method to generate the complete datagram.
	 * @return datagram with padding
	 */
	public byte[] toDatagram() {
		byte[] datagram; // java initialize all to zero
		// size is keep blank (ProtocolP2PDatagram will handle it)
		// set request/response code
		datagram[RequestResponseCode.RRCODE_POSITION] = requestResponseCode.codeValue;
		// bits 16-31 are reserved for future use
		//TODO size
		int size = ;
		datagram = setPayloadSize(size, datagram);
		//TODO content
	}

}
